/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Parser.xs. Do not edit this file, edit Parser.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Parser.xs"
/* $Id: Parser.xs,v 2.113 2002/03/08 03:49:23 gisle Exp $
 *
 * Copyright 1999-2001, Gisle Aas.
 * Copyright 1999-2000, Michael A. Chase.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the same terms as Perl itself.
 */


/*
 * Standard XS greeting.
 */
#ifdef __cplusplus
extern "C" {
#endif
#define PERL_NO_GET_CONTEXT     /* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif



/*
 * Some perl version compatibility gruff.
 */
#include "patchlevel.h"
#if PATCHLEVEL <= 4 /* perl5.004_XX */

#ifndef PL_sv_undef
   #define PL_sv_undef sv_undef
   #define PL_sv_yes   sv_yes
#endif

#ifndef PL_hexdigit
   #define PL_hexdigit hexdigit
#endif

#ifndef ERRSV
   #define ERRSV GvSV(errgv)
#endif

#if (PATCHLEVEL == 4 && SUBVERSION <= 4)
/* The newSVpvn function was introduced in perl5.004_05 */
static SV *
newSVpvn(char *s, STRLEN len)
{
    register SV *sv = newSV(0);
    sv_setpvn(sv,s,len);
    return sv;
}
#endif /* not perl5.004_05 */
#endif /* perl5.004_XX */

#ifndef dNOOP
   #define dNOOP extern int errno
#endif
#ifndef dTHX
   #define dTHX dNOOP
   #define pTHX_
   #define aTHX_
#endif

#ifndef MEMBER_TO_FPTR
   #define MEMBER_TO_FPTR(x) (x)
#endif

#ifndef INT2PTR
   #define INT2PTR(any,d)  (any)(d)
   #define PTR2IV(p)       (IV)(p)
#endif


#if PATCHLEVEL > 6 || (PATCHLEVEL == 6 && SUBVERSION > 0)
   #define RETHROW	   croak(Nullch)
#else
   #define RETHROW    { STRLEN my_na; croak("%s", SvPV(ERRSV, my_na)); }
#endif

/*
 * Include stuff.  We include .c files instead of linking them,
 * so that they don't have to pollute the external dll name space.
 */

#ifdef EXTERN
  #undef EXTERN
#endif

#define EXTERN static /* Don't pollute */

#include "hparser.h"
#include "util.c"
#include "hparser.c"


/*
 * Support functions for the XS glue
 */

static SV*
check_handler(SV* h)
{
    dTHX;
    if (SvROK(h)) {
	SV* myref = SvRV(h);
	if (SvTYPE(myref) == SVt_PVCV)
	    return newSVsv(h);
	if (SvTYPE(myref) == SVt_PVAV)
	    return SvREFCNT_inc(myref);
	croak("Only code or array references allowed as handler");
    }
    return SvOK(h) ? newSVsv(h) : 0;
}


static PSTATE*
get_pstate_iv(SV* sv)
{
    dTHX;
    PSTATE* p = INT2PTR(PSTATE*, SvIV(sv));
    if (p->signature != P_SIGNATURE)
	croak("Bad signature in parser state object at %p", p);
    return p;
}


static PSTATE*
get_pstate_hv(SV* sv)                               /* used by XS typemap */
{
    dTHX;
    HV* hv;
    SV** svp;

    sv = SvRV(sv);
    if (!sv || SvTYPE(sv) != SVt_PVHV)
	croak("Not a reference to a hash");
    hv = (HV*)sv;
    svp = hv_fetch(hv, "_hparser_xs_state", 17, 0);
    if (svp) {
	if (SvROK(*svp))
	    return get_pstate_iv(SvRV(*svp));
	else
	    croak("_hparser_xs_state element is not a reference");
    }
    croak("Can't find '_hparser_xs_state' element in HTML::Parser hash");
    return 0;
}


static void
free_pstate(PSTATE* pstate)
{
    dTHX;
    int i;
    SvREFCNT_dec(pstate->buf);
    SvREFCNT_dec(pstate->pend_text);
    SvREFCNT_dec(pstate->skipped_text);
#ifdef MARKED_SECTION
    SvREFCNT_dec(pstate->ms_stack);
#endif
    SvREFCNT_dec(pstate->bool_attr_val);
    for (i = 0; i < EVENT_COUNT; i++) {
	SvREFCNT_dec(pstate->handlers[i].cb);
	SvREFCNT_dec(pstate->handlers[i].argspec);
    }

    SvREFCNT_dec(pstate->report_tags);
    SvREFCNT_dec(pstate->ignore_tags);
    SvREFCNT_dec(pstate->ignore_elements);
    SvREFCNT_dec(pstate->ignoring_element);

    SvREFCNT_dec(pstate->tmp);

    pstate->signature = 0;
    Safefree(pstate);
}


static int
magic_free_pstate(pTHX_ SV *sv, MAGIC *mg)
{
    free_pstate(get_pstate_iv(sv));
    return 0;
}


MGVTBL vtbl_free_pstate = {0, 0, 0, 0, MEMBER_TO_FPTR(magic_free_pstate)};



/*
 *  XS interface definition.
 */

#line 208 "Parser.c"
XS(XS_HTML__Parser__alloc_pstate); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Parser__alloc_pstate)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: HTML::Parser::_alloc_pstate(self)");
    {
	SV*	self = ST(0);
#line 206 "Parser.xs"
	PSTATE* pstate;
	SV* sv;
	HV* hv;
        MAGIC* mg;

#line 223 "Parser.c"
#line 212 "Parser.xs"
	sv = SvRV(self);
        if (!sv || SvTYPE(sv) != SVt_PVHV)
            croak("Not a reference to a hash");
	hv = (HV*)sv;

	Newz(56, pstate, 1, PSTATE);
	pstate->signature = P_SIGNATURE;
	pstate->entity2char = perl_get_hv("HTML::Entities::entity2char", TRUE);
	pstate->tmp = NEWSV(0, 20);

	sv = newSViv(PTR2IV(pstate));
	sv_magic(sv, 0, '~', 0, 0);
	mg = mg_find(sv, '~');
        assert(mg);
        mg->mg_virtual = &vtbl_free_pstate;
	SvREADONLY_on(sv);

	hv_store(hv, "_hparser_xs_state", 17, newRV_noinc(sv), 0);
#line 243 "Parser.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_HTML__Parser_parse); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Parser_parse)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: HTML::Parser::parse(self, chunk)");
    {
	SV*	self = ST(0);
	SV*	chunk = ST(1);
#line 236 "Parser.xs"
	PSTATE* p_state = get_pstate_hv(self);
#line 259 "Parser.c"
	SV *	RETVAL;
#line 238 "Parser.xs"
	if (p_state->parsing)
    	    croak("Parse loop not allowed");
        p_state->parsing = 1;
	if (SvROK(chunk) && SvTYPE(SvRV(chunk)) == SVt_PVCV) {
	    SV* generator = chunk;
	    STRLEN len;
	    do {
		dSP;
                int count;
		PUSHMARK(SP);
	        count = perl_call_sv(generator, G_SCALAR|G_EVAL);
		SPAGAIN;
		chunk = count ? POPs : 0;

	        if (SvTRUE(ERRSV)) {
		    p_state->parsing = 0;
		    p_state->eof = 0;
		    RETHROW;
                }

		if (chunk && SvOK(chunk)) {
		    (void)SvPV(chunk, len);  /* get length */
		}
		else {
		    len = 0;
                }
		parse(aTHX_ p_state, len ? chunk : 0, self);

            } while (len && !p_state->eof);
        }
	else {
	    parse(aTHX_ p_state, chunk, self);
        }
        p_state->parsing = 0;
	if (p_state->eof) {
	    p_state->eof = 0;
            ST(0) = sv_newmortal();
        }
#line 300 "Parser.c"
    }
    XSRETURN(1);
}

XS(XS_HTML__Parser_eof); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Parser_eof)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: HTML::Parser::eof(self)");
    {
	SV*	self = ST(0);
#line 281 "Parser.xs"
	PSTATE* p_state = get_pstate_hv(self);
#line 315 "Parser.c"
	SV *	RETVAL;
#line 283 "Parser.xs"
        if (p_state->parsing)
            p_state->eof = 1;
        else {
	    p_state->parsing = 1;
	    parse(aTHX_ p_state, 0, self); /* flush */
	    p_state->parsing = 0;
	}
#line 325 "Parser.c"
    }
    XSRETURN(1);
}

XS(XS_HTML__Parser_strict_comment); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Parser_strict_comment)
{
    dXSARGS;
    dXSI32;
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(pstate, ...)", GvNAME(CvGV(cv)));
    {
	PSTATE*	pstate = get_pstate_hv(ST(0));
#line 303 "Parser.xs"
	bool *attr;
#line 341 "Parser.c"
	SV *	RETVAL;
#line 305 "Parser.xs"
        switch (ix) {
	case  1: attr = &pstate->strict_comment;       break;
	case  2: attr = &pstate->strict_names;         break;
	case  3: attr = &pstate->xml_mode;             break;
	case  4: attr = &pstate->unbroken_text;        break;
        case  5:
#ifdef MARKED_SECTION
		 attr = &pstate->marked_sections;      break;
#else
	         croak("marked sections not supported"); break;
#endif
	case  6: attr = &pstate->attr_encoded;         break;
	case  7: attr = &pstate->case_sensitive;       break;
	default:
	    croak("Unknown boolean attribute (%d)", ix);
        }
	RETVAL = boolSV(*attr);
	if (items > 1)
	    *attr = SvTRUE(ST(1));
#line 363 "Parser.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_HTML__Parser_boolean_attribute_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Parser_boolean_attribute_value)
{
    dXSARGS;
    if (items < 1)
	Perl_croak(aTHX_ "Usage: HTML::Parser::boolean_attribute_value(pstate, ...)");
    {
	PSTATE*	pstate = get_pstate_hv(ST(0));
	SV *	RETVAL;
#line 331 "Parser.xs"
	RETVAL = pstate->bool_attr_val ? newSVsv(pstate->bool_attr_val)
				       : &PL_sv_undef;
	if (items > 1) {
	    SvREFCNT_dec(pstate->bool_attr_val);
	    pstate->bool_attr_val = newSVsv(ST(1));
        }
#line 386 "Parser.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_HTML__Parser_ignore_tags); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Parser_ignore_tags)
{
    dXSARGS;
    dXSI32;
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(pstate, ...)", GvNAME(CvGV(cv)));
    {
	PSTATE*	pstate = get_pstate_hv(ST(0));
#line 348 "Parser.xs"
	HV** attr;
	int i;
#line 405 "Parser.c"
#line 351 "Parser.xs"
	switch (ix) {
	case  1: attr = &pstate->report_tags;     break;
	case  2: attr = &pstate->ignore_tags;     break;
	case  3: attr = &pstate->ignore_elements; break;
	default:
	    croak("Unknown tag-list attribute (%d)", ix);
	}
	if (GIMME_V != G_VOID)
	    croak("Can't report tag lists yet");

	items--;  /* pstate */
	if (items) {
	    if (*attr)
		hv_clear(*attr);
	    else
		*attr = newHV();

	    for (i = 0; i < items; i++) {
		SV* sv = ST(i+1);
		if (SvROK(sv)) {
		    sv = SvRV(sv);
		    if (SvTYPE(sv) == SVt_PVAV) {
			AV* av = (AV*)sv;
			STRLEN j;
			STRLEN len = av_len(av) + 1;
			for (j = 0; j < len; j++) {
			    SV**svp = av_fetch(av, j, 0);
			    if (svp) {
				hv_store_ent(*attr, *svp, newSViv(0), 0);
			    }
			}
		    }
		    else
			croak("Tag list must be plain scalars and arrays");
		}
		else {
		    hv_store_ent(*attr, sv, newSViv(0), 0);
		}
	    }
	}
	else if (*attr) {
	    SvREFCNT_dec(*attr);
            *attr = 0;
	}
#line 451 "Parser.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_HTML__Parser_handler); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Parser_handler)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: HTML::Parser::handler(pstate, eventname, ...)");
    {
	PSTATE*	pstate = get_pstate_hv(ST(0));
	SV*	eventname = ST(1);
#line 401 "Parser.xs"
	SV* self = ST(0);
	STRLEN name_len;
	char *name = SvPV(eventname, name_len);
        int event = -1;
        int i;
        struct p_handler *h;
#line 472 "Parser.c"
	SV *	RETVAL;
#line 408 "Parser.xs"
	/* map event name string to event_id */
	for (i = 0; i < EVENT_COUNT; i++) {
	    if (strEQ(name, event_id_str[i])) {
	        event = i;
	        break;
	    }
	}
        if (event < 0)
	    croak("No handler for %s events", name);

	h = &pstate->handlers[event];

	/* set up return value */
	if (h->cb) {
	    ST(0) = (SvTYPE(h->cb) == SVt_PVAV)
	                 ? sv_2mortal(newRV_inc(h->cb))
	                 : sv_2mortal(newSVsv(h->cb));
	}
        else {
	    ST(0) = &PL_sv_undef;
        }

        /* update */
        if (items > 3) {
	    SvREFCNT_dec(h->argspec);
	    h->argspec = 0;
	    h->argspec = argspec_compile(ST(3), pstate);
	}
        if (items > 2) {
	    SvREFCNT_dec(h->cb);
            h->cb = 0;
	    h->cb = check_handler(ST(2));
	}
#line 508 "Parser.c"
    }
    XSRETURN(1);
}

XS(XS_HTML__Entities_decode_entities); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Entities_decode_entities)
{
    dXSARGS;
   PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 448 "Parser.xs"
        int i;
	HV *entity2char = perl_get_hv("HTML::Entities::entity2char", FALSE);
#line 523 "Parser.c"
#line 451 "Parser.xs"
	if (GIMME_V == G_SCALAR && items > 1)
            items = 1;
	for (i = 0; i < items; i++) {
	    if (GIMME_V != G_VOID)
	        ST(i) = sv_2mortal(newSVsv(ST(i)));
	    else if (SvREADONLY(ST(i)))
		croak("Can't inline decode readonly string");
	    decode_entities(aTHX_ ST(i), entity2char);
	}
	SP += items;
#line 535 "Parser.c"
	PUTBACK;
	return;
    }
}

XS(XS_HTML__Entities__decode_entities); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Entities__decode_entities)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: HTML::Entities::_decode_entities(string, entities)");
    {
	SV*	string = ST(0);
	SV*	entities = ST(1);
#line 467 "Parser.xs"
	HV* entities_hv;
#line 552 "Parser.c"
#line 469 "Parser.xs"
        if (SvOK(entities)) {
	    if (SvROK(entities) && SvTYPE(SvRV(entities)) == SVt_PVHV) {
		entities_hv = (HV*)SvRV(entities);
	    }
            else {
		croak("2nd argument must be hash reference");
            }
        }
        else {
            entities_hv = 0;
        }
	if (SvREADONLY(string))
	    croak("Can't inline decode readonly string");
	decode_entities(aTHX_ string, entities_hv);
#line 568 "Parser.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_HTML__Entities_UNICODE_SUPPORT); /* prototype to pass -Wmissing-prototypes */
XS(XS_HTML__Entities_UNICODE_SUPPORT)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: HTML::Entities::UNICODE_SUPPORT()");
    {
	int	RETVAL;
	dXSTARG;
#line 488 "Parser.xs"
#ifdef UNICODE_ENTITIES
       RETVAL = 1;
#else
       RETVAL = 0;
#endif
#line 588 "Parser.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_HTML__Parser); /* prototype to pass -Wmissing-prototypes */
XS(boot_HTML__Parser)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("HTML::Parser::_alloc_pstate", XS_HTML__Parser__alloc_pstate, file);
        newXS("HTML::Parser::parse", XS_HTML__Parser_parse, file);
        newXS("HTML::Parser::eof", XS_HTML__Parser_eof, file);
        cv = newXS("HTML::Parser::unbroken_text", XS_HTML__Parser_strict_comment, file);
        XSANY.any_i32 = 4 ;
        cv = newXS("HTML::Parser::xml_mode", XS_HTML__Parser_strict_comment, file);
        XSANY.any_i32 = 3 ;
        cv = newXS("HTML::Parser::strict_comment", XS_HTML__Parser_strict_comment, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("HTML::Parser::marked_sections", XS_HTML__Parser_strict_comment, file);
        XSANY.any_i32 = 5 ;
        cv = newXS("HTML::Parser::attr_encoded", XS_HTML__Parser_strict_comment, file);
        XSANY.any_i32 = 6 ;
        cv = newXS("HTML::Parser::case_sensitive", XS_HTML__Parser_strict_comment, file);
        XSANY.any_i32 = 7 ;
        cv = newXS("HTML::Parser::strict_names", XS_HTML__Parser_strict_comment, file);
        XSANY.any_i32 = 2 ;
        newXS("HTML::Parser::boolean_attribute_value", XS_HTML__Parser_boolean_attribute_value, file);
        cv = newXS("HTML::Parser::ignore_tags", XS_HTML__Parser_ignore_tags, file);
        XSANY.any_i32 = 2 ;
        cv = newXS("HTML::Parser::ignore_elements", XS_HTML__Parser_ignore_tags, file);
        XSANY.any_i32 = 3 ;
        cv = newXS("HTML::Parser::report_tags", XS_HTML__Parser_ignore_tags, file);
        XSANY.any_i32 = 1 ;
        newXS("HTML::Parser::handler", XS_HTML__Parser_handler, file);
        newXS("HTML::Entities::decode_entities", XS_HTML__Entities_decode_entities, file);
        newXS("HTML::Entities::_decode_entities", XS_HTML__Entities__decode_entities, file);
        newXSproto("HTML::Entities::UNICODE_SUPPORT", XS_HTML__Entities_UNICODE_SUPPORT, file, "");
    }
    XSRETURN_YES;
}

